package planetwars;

import com.google.gson.JsonObject;


/**
 * Stelt een expeditie voor.
 */
public record Expedition (
    int id,                 // Id van een expeditie, heb je niet nodig
    int shipCount,          // Aantal schepen die hierbij betrokken zijn
    Planet origin,          // Planeet van waar ze komen
    Planet destination,     // Planeet waar ze naar toe gaan
    int owner,              // Speler die ze verstuurd heeft, 1 -> jij, anders -> tegenstander
    int turnsRemaining      // Hoeveel beurten nog tot ze toekomen
) {


    /**
     * Maakt een expeditie aan op basis van de input van het spel.
     * 
     * @param expedition    | Input
     * @param planets       | Alle planeten van die beurt
     */
    public Expedition(JsonObject expedition, Planet originPlanet, Planet destinationPlanet) {
        this (
            expedition.get("id").getAsInt(),
            expedition.get("ship_count").getAsInt(),
            originPlanet,
            destinationPlanet,
            expedition.get("owner").getAsInt(),
            expedition.get("turns_remaining").getAsInt()
        );
    }
}
