package planetwars;

import com.google.gson.JsonObject;


/**
 * Stelt een zet voor.
 */
public record Move(
    Planet origin,      // Planeet van waar het komt
    Planet destination, // Planeet waar het naar toe gaat
    int shipCount       // Hoeveel schepen er naar toe gaan
) {


    /**
     * Maakt een json object van de data die het bevat.
     * 
     * @return  | Het json object.
     */
    public JsonObject toJson() {
        JsonObject move = new JsonObject();
        move.addProperty("origin", origin.name());
        move.addProperty("destination", destination.name());
        move.addProperty("ship_count", shipCount);
        return move;
    }
}
